﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = CreateTable();
        }

        private DataTable CreateTable()
        {
            DataTable table = new DataTable();
            for (int i = 0; i < 15; i++)
            {
                DataColumn column = table.Columns.Add("KEY" + i.ToString());
                if (i % 4 == 0)
                    column.DataType = typeof(bool);
            }

            table.Rows.Add(new object[] { false, "A111", "A222", "A333", false, "A555", "A666", "A777", false, "A999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "A111", "A222", "A333", false, "A555", "A666", "A777", false, "A999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "A111", "A222", "A333", false, "A555", "A666", "A777", false, "A999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "B111", "B222", "B333", false, "B555", "B666", "B777", false, "B999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "B111", "B222", "B333", false, "B555", "B666", "B777", false, "B999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "B111", "B222", "B333", false, "B555", "B666", "B777", false, "B999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "C111", "C222", "C333", false, "C555", "C666", "C777", false, "C999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "C111", "C222", "C333", false, "C555", "C666", "C777", false, "C999", "AAA", "BBB", false, "DDD", "EEE" });
            table.Rows.Add(new object[] { false, "C111", "C222", "C333", false, "C555", "C666", "C777", false, "C999", "AAA", "BBB", false, "DDD", "EEE" });

            return table;            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            for (int i = 0; i < 15; i += 4)
            {
                e.Layout.Bands[0].Columns[i].Header.CheckBoxVisibility = HeaderCheckBoxVisibility.Always;
                e.Layout.Bands[0].Columns[i].Header.CheckBoxSynchronization = HeaderCheckBoxSynchronization.None;
            }
        }

        private void ultraGrid1_BeforeHeaderCheckStateChanged(object sender, BeforeHeaderCheckStateChangedEventArgs e)
        {
            foreach (UltraGridRow row in e.Rows)
                row.Cells[e.Column].SetValue((e.NewCheckState == CheckState.Checked), true);
        }

        private void ultraGrid1_AfterRowFilterChanged(object sender, AfterRowFilterChangedEventArgs e)
        {
        }
    }
}
